package com.starcharge.wios.Import.impl;

import com.starcharge.wios.Import.Import;
import com.starcharge.wios.dao.entity.Order;
import com.starcharge.wios.dao.mappers.OrderMapper;
import com.starcharge.wios.enums2.ProductType;
import com.starcharge.wios.validation.CreateEntityGroup;
import com.starcharge.wios.vo.DeliveryAddVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.validation.ConstraintViolation;
import javax.validation.Validator;
import java.util.List;
import java.util.Set;

/**
 * @projectName:xr-wios
 * @packageName:com.starcharge.wios.Import.impl
 * @Description:TODO
 * @Author:luyincheng
 * @CreateDate: 2023/10/1317:01
 */
@Service
public class AuxiliaryMaterialDeliveryImport implements Import {

    public interface AuxiliaryBatchCreateEntityGroup {
    }

    @Autowired
    private Validator validator;
    @Autowired
    private OrderMapper orderMapper;

    @Override
    public List<?> handle(List<Object> list) {
//        List<String> headList = (List<String>)list.get(0);
        for(int i=1;i<list.size();i++){
            List<String> rowdata = (List<String>)list.get(i);
            DeliveryAddVo deliveryAddVo=new DeliveryAddVo();
            deliveryAddVo.setInstallOrder(rowdata.get(0));
            deliveryAddVo.setMaterialCode(rowdata.get(1));
            deliveryAddVo.setMaterialName(rowdata.get(2));
            deliveryAddVo.setMaterialCompany(rowdata.get(3));
            deliveryAddVo.setLogisticOrder(rowdata.get(4));
            deliveryAddVo.setTeam(rowdata.get(5));
            //deliveryAddVo.setWarehouseName(rowdata.get(6));
            //deliveryAddVo.set

            Set<ConstraintViolation<DeliveryAddVo>> sets =  validator.validate(deliveryAddVo, AuxiliaryMaterialDeliveryImport.AuxiliaryBatchCreateEntityGroup.class);
            if(!sets.isEmpty()){
                rowdata.add(sets.stream().map(ConstraintViolation::getMessage).reduce("error:",(s1,s2)->s1+";"+s2));
                continue;
            }
        }
        return list;
    }
}
