package com.starcharge.wios.dao.entity;

import com.starcharge.wios.validation.CreateEntityGroup;
import com.starcharge.wios.validation.UpdateEntityGroup;
import com.starcharge.wios.vo.PageVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Range;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
*@description:: $discription$
*@author:luyc
*@time:2023-10-08 18:07:04 下午
 */
@Data
@ApiModel(value="Delivery", description="发货单")
public class Delivery extends PageVo implements Serializable {
    /**
     * id
     *
     * @mbg.generated
     */
    @ApiModelProperty(required = true,value = "id")
    @NotNull(groups = UpdateEntityGroup.class )
    @Min(value = 1,groups = UpdateEntityGroup.class)
    private Integer id;

    /**
     * 发货单号
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "发货单号")
    private String deliveryOrder;

    /**
     * 安装单号
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "安装单号")
    private String installOrder;

    /**
     * 产品批次
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "产品批次")
    private String productBatch;

    /**
     * 发货数量
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "发货数量")
    private Integer quantity;

    /**
     * 物料类别
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "物料类别")
    private String materialCategory;

    /**
     * 物料编码
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "物料编码")
    private String materialCode;

    /**
     * 物料名称
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "物料名称")
    private String materialName;

    /**
     * 物料厂商
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "物料厂商")
    private String materialCompany;

    /**
     * 物流单号
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "物流单号")
    private String logisticOrder;

    /**
     * 物流服务商
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "物流服务商")
    private String logisticCompany;

    /**
     * 物流状态  未发货  已发货
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "物流状态  未发货  已发货")
    private String logisticStatus;
    /**
     * 申请团队
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "申请团队")
    private String team;
    /**
     * 是否产品或辅料
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "是否产品或辅料 1 是 0 否")
    @NotNull(groups = CreateEntityGroup.class)
    private String isproduct;
    /**
     * 创建人
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "创建人")
    private String createdBy;

    /**
     * 创建时间
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createdTime;

    /**
     * 更新人
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "更新人")
    private String updatedBy;

    /**
     * 更新时间
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "更新时间")
    private LocalDateTime updatedTime;
    /**
     * 到货仓库
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "到货仓库")
    private String arrivalWarehouse;

    /**
     * 到货仓库id
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "到货仓库id")
    private String arrivalWarehouseId;

    /**
     * 收货人
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "收货人")
    private String receiver;
    /**
     * 申请表
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "申请表")
    private String remarks;
    /**
     * 退货材料
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "退货材料")
    private String rejectMaterial;
    /**
     * 退货原因
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "退货原因")
    private String reason;
    /**
     * 状态集合
     *
     * @mbg.generated
     */
    private List<String> logisticStatusList;
    /**
     * 退货的审批时间
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "退货的审批时间")
    private LocalDateTime checkTime;
    /**
     * 退货的审核人
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "退货的审核人")
    private String checkUser;
    /**
     * 退货的审核人姓名
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "退货的审核人姓名")
    private String checkUserName;
    /**
     * 退货的审核意见
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "退货的审核意见")
    private String checkSuggestion;
    /**
     * 车企单号
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "车企单号")
    private String outOrderId;
    /**
     * 退货的物流单号
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "退货的物流单号")
    private String rejectLogisticOrder;
    /**
     * 到货数量
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "到货数量")
    private Integer arrivalQuantity;

    /**
     * 辅料申请单号
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "辅料申请单号")
    private Integer auxiliaryId;
    /**
     * 文件地址
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "文件地址")
    private String fileUrl;
    /**
     * 物料的SN号
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "物料的SN号")
    private String materialSn;
    /**
     * 安装状态,0-未安装，1-已安装
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "安装状态,0-未安装，1-已安装")
    private Integer installStatus;
    /**
     * 发货仓库id
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "发货仓库id")
    private String warehouseId;
    /**
     * 发货仓库
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "发货仓库")
    private String warehouseName;
    /**
     * 收货人电话
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "收货人电话")
    private String receiverPhone;
    /**
     * 发货人
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "发货人")
    private String sender;
    /**
     * 发货人电话
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "发货人电话")
    private String senderPhone;
    /**
     * 收货地址
     *
     * @mbg.generated
     */
    @ApiModelProperty(value = "收货地址")
    private String receiveAddress;

    private static final long serialVersionUID = 1L;


}